package RandomNumbers
--# own State;
--# initializes State;
is 
  procedure Random(X : out Float);
  --# global in out State;
  --# derives X, State 
  --#    from State;
end RandomNumbers;

package body RandomNumbers is
  State : Integer;
  procedure Random(X : out Float) is
  --# hide Random
  --  ... implementation of Random
  end Random;
begin 
  State := 2**15 - 1;
end RandomNumbers;

with 	RandomNumbers, 
	SPARK_IO; 
--# inherit RandomNumbers,
--#         SPARK_IO;

--# main_program;
procedure Main
--# global in out RandomNumbers.State;
--# derives RandomNumbers.State
--#    from * ;
is
  X : Float;
begin
  RandomNumbers.Random(X);
  SPARK_IO.Put_Integer(SPARK_IO.Standard_Output,
                       Integer(X * 10.0), 0, 10);
end Main;
